{{ BitManipulator.spin
  Use to view and manipulate bits, see subroutines for details. To include object:

  OBJ
    BIT : "BitManipulator"
}}

PUB VIEW (VALUE, BIT)
{{ Views the specified bit (0-31) of the specified value and returns the state (0-1)
  MYNUM  := %0100              '                        'Set MYNUM to %0100
  NUMBIT := BIT.VIEW(MYNUM, 2)                          'Change NUMBIT to 2nd bit of MYNUM which is 1
}}
  IF (BIT < 0) OR (BIT > 31)    'Return -1 if BIT < 0 or > 31
    RETURN -1
  RETURN VALUE >> BIT >< 1      'Return the bit

PUB CHANGE (VALUE, BIT, STATE)
{{ Changes the specified bit (0 - 31) of the value to the specified state (-1 to 1) & returns the new value
   STATE: -1 - Invert, 0 - Set low, 1 - Set high

  MYNUM := %1110_0011                                   'Set MYNUM to %1110_0011
  MYNUM := BIT.CHANGE(MYNUM, 6, 0)                      'Change MYNUM to %1010_0011
}}

  IF (BIT < 0) OR (BIT > 31) OR (STATE < -1) OR (STATE > 1)  'Prevent errors
    RETURN VALUE                                        'Return -1
  IF (STATE <> -1)                                      'If state non-invert
    IF (VIEW(VALUE, BIT) <> STATE)
      IF STATE                                          'Return with stated bit 1
        RETURN VALUE + |< BIT
      ELSE                                              'Return with stated bit 0
        RETURN VALUE - |< BIT
  ELSE
    IF VIEW(VALUE, BIT)                                 'Invert bit
      RETURN VALUE - |< BIT                             'Return with stated bit 0 if 1
    ELSE
      RETURN VALUE + |< BIT                             'Return with stated bit 1 if 0
  RETURN VALUE                                          'Return value without editing if already state

PUB FILL (VALUE, START, FINISH, STATE)
{{ Fills the specified bits (0-31) of the value with the specified state (-1 to 1)
   STATE: -1 - Invert, 0 - Set low, 1 - Set high

  MYNUM := %1010_0110                                   'Set MYNUM to %1010_0110
  MYNUM := BIT.FILL(MYNUM, 1, 6, -1)                    'Change MYNUM to %1101_1010
}}
  IF (START < 0) OR (START > 31) OR (START > FINISH) OR (FINISH < 0) OR (FINISH > 31) OR (STATE < -1) OR (STATE > 1)
    RETURN -1
  REPEAT UNTIL (START => FINISH + 1)
    VALUE := CHANGE(VALUE, START++, STATE)
  RETURN VALUE

